Discover ClickPipe source schema
This endpoint is in beta. API contract is stable, and no breaking changes are expected in the future.
Infers the schema (field names and ClickHouse data types) of a streaming ClickPipe source without creating a pipe. Supported for Kafka and Kinesis sources.
POST
/
v1
/
organizations
/
{organizationId}
/
services
/
{serviceId}
/
clickpipes
/
schemaDiscovery
Discover ClickPipe source schema
curl --request POST \
--url https://api.clickhouse.cloud/v1/organizations/{organizationId}/services/{serviceId}/clickpipes/schemaDiscovery \
--header 'Authorization: Basic <encoded-value>' \
--header 'Content-Type: application/json' \
--data '
{
"source": {
"kafka": {
"brokers": "<string>",
"topics": "<string>",
"consumerGroup": "my-clickpipe-consumer-group",
"iamRole": "arn:aws:iam::123456789012:role/MyRole",
"offset": {
"timestamp": "2021-01-01T00:00"
},
"schemaRegistry": {
"url": "https://psrc-aa00.us-east-2.aws.confluent.cloud/schemas/ids/100004",
"authentication": "PLAIN",
"caCertificate": "<string>",
"credentials": {
"username": "<string>",
"password": "<string>"
}
},
"caCertificate": "<string>",
"reversePrivateEndpointIds": [
"<string>"
],
"exactlyOnce": true,
"credentials": {
"username": "postgres_user",
"password": "your_secure_password"
}
},
"kinesis": {
"streamName": "my-stream",
"region": "us-east-1",
"useEnhancedFanOut": true,
"timestamp": 1615766400,
"iamRole": "arn:aws:iam::123456789012:role/MyRole",
"accessKey": {
"accessKeyId": "<string>",
"secretKey": "<string>"
}
}
}
}
'import requests
url = "https://api.clickhouse.cloud/v1/organizations/{organizationId}/services/{serviceId}/clickpipes/schemaDiscovery"
payload = { "source": {
"kafka": {
"brokers": "<string>",
"topics": "<string>",
"consumerGroup": "my-clickpipe-consumer-group",
"iamRole": "arn:aws:iam::123456789012:role/MyRole",
"offset": { "timestamp": "2021-01-01T00:00" },
"schemaRegistry": {
"url": "https://psrc-aa00.us-east-2.aws.confluent.cloud/schemas/ids/100004",
"authentication": "PLAIN",
"caCertificate": "<string>",
"credentials": {
"username": "<string>",
"password": "<string>"
}
},
"caCertificate": "<string>",
"reversePrivateEndpointIds": ["<string>"],
"exactlyOnce": True,
"credentials": {
"username": "postgres_user",
"password": "your_secure_password"
}
},
"kinesis": {
"streamName": "my-stream",
"region": "us-east-1",
"useEnhancedFanOut": True,
"timestamp": 1615766400,
"iamRole": "arn:aws:iam::123456789012:role/MyRole",
"accessKey": {
"accessKeyId": "<string>",
"secretKey": "<string>"
}
}
} }
headers = {
"Authorization": "Basic <encoded-value>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Basic <encoded-value>', 'Content-Type': 'application/json'},
body: JSON.stringify({
source: {
kafka: {
brokers: '<string>',
topics: '<string>',
consumerGroup: 'my-clickpipe-consumer-group',
iamRole: 'arn:aws:iam::123456789012:role/MyRole',
offset: {timestamp: '2021-01-01T00:00'},
schemaRegistry: {
url: 'https://psrc-aa00.us-east-2.aws.confluent.cloud/schemas/ids/100004',
authentication: 'PLAIN',
caCertificate: '<string>',
credentials: {username: '<string>', password: '<string>'}
},
caCertificate: '<string>',
reversePrivateEndpointIds: ['<string>'],
exactlyOnce: true,
credentials: {username: 'postgres_user', password: 'your_secure_password'}
},
kinesis: {
streamName: 'my-stream',
region: 'us-east-1',
useEnhancedFanOut: true,
timestamp: 1615766400,
iamRole: 'arn:aws:iam::123456789012:role/MyRole',
accessKey: {accessKeyId: '<string>', secretKey: '<string>'}
}
}
})
};
fetch('https://api.clickhouse.cloud/v1/organizations/{organizationId}/services/{serviceId}/clickpipes/schemaDiscovery', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": 200,
"requestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"result": {
"fields": [
{
"name": "user_id",
"type": "Int64",
"optional": true
}
]
}
}{
"status": 400,
"error": "<string>",
"requestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}{
"status": 500,
"error": "<string>",
"requestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}Beta
This endpoint is in beta. API contract is stable, and no breaking changes are expected in the future.
Infers the schema (field names and ClickHouse data types) of a streaming ClickPipe source without creating a pipe. Supported for Kafka and Kinesis sources.
Infers the schema (field names and ClickHouse data types) of a streaming ClickPipe source without creating a pipe. Supported for Kafka and Kinesis sources.
Authorizations
Use key ID and key secret obtained in ClickHouse Cloud console: https://clickhouse.com/docs/cloud/manage/openapi
Path Parameters
ID of the organization that owns the service.
ID of the service to run schema discovery against.
Body
application/json
Show child attributes
Show child attributes
Last modified on July 9, 2026
Was this page helpful?
Previous
Update ClickPipe scalingChange scaling settings for the specified ClickPipe. This endpoint supports Kafka, Kinesis, and object storage pipes (S3, GCS, Azure Blob).
**Note:** For database ClickPipes (PostgreSQL, MySQL, MongoDB, BigQuery), use the [Update CDC ClickPipes scaling](#tag/ClickPipes/operation/clickPipeCdcScalingUpdate) endpoint instead.
Next
⌘I
Discover ClickPipe source schema
